# Generated by Django 4.2.9 on 2024-01-25 14:00
from django.db import migrations, models
from django.db.models import Max, F
import django.db.models.functions.comparison


def create_size_category_from_max_size(apps, schema_editor):
    Event = apps.get_model('events', 'Event')
    SizeCategory = apps.get_model('teams', 'SizeCategory')
    schema_name = schema_editor.connection.schema_name
    try:
        event = Event.objects.get(schema_name=schema_name)

        if event.max_team_size:
            SizeCategory(max=event.max_team_size).save()
        event.max_team_size = 0
        event.save()
    except Event.DoesNotExist:
        pass


def set_max_size_from_categories(apps, schema_editor):
    Event = apps.get_model('events', 'Event')
    SizeCategory = apps.get_model('teams', 'SizeCategory')
    schema_name = schema_editor.connection.schema_name
    event = Event.objects.get(schema_name=schema_name)

    if SizeCategory.objects.filter(max=None).exists():
        max_size = None
    else:
        max_size = SizeCategory.objects.aggregate(max=Max('max'))['max']

    event.max_team_size = max_size if max_size is not None else 0
    event.save()


class Migration(migrations.Migration):

    dependencies = [
        ('teams', '0010_team_disqualified'),
    ]

    operations = [
        migrations.CreateModel(
            name='SizeCategory',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('max', models.PositiveSmallIntegerField(blank=True, help_text='Maximum team size (inclusive) to fit in this category, or blank for no limit', null=True)),
                ('label', models.CharField(blank=True, max_length=255, help_text='Rendered as HTML. Displayed to players to identify the category. If left blank, the range will be used instead.')),
                ('description', models.TextField(blank=True, help_text='Rendered as HTML. Displayed when explaining the categories to players.')),
            ],
            options={
                'ordering': [F('max').asc(nulls_last=True)],
                'constraints': [models.UniqueConstraint(django.db.models.functions.comparison.Coalesce('max', -1), violation_error_message='Size category maximum must be unique within an event.', name='teams_sizecategory_unique_max')],
            },
        ),
        migrations.RunPython(
            code=create_size_category_from_max_size,
            reverse_code=set_max_size_from_categories,
        )
    ]
